﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace LocalReportsWithBarcodeInHeaderFooterCS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.textBox1.Text = "000111222333";

            UpdateBarcodeOnHeader();
        }


        private void UpdateBarcodeOnHeader()
        {

            if (this.textBox1.Text.Trim() == "")
            {
                MessageBox.Show("Please enter a value to encode, thanks!");
                return;
            }


            string barcodeBase64 = "";

            //Create an instance of Barcode Professional 
            using (Neodynamic.WinControls.BarcodeProfessional.BarcodeProfessional bcp = new Neodynamic.WinControls.BarcodeProfessional.BarcodeProfessional())
            {
                //Barcode settings
                bcp.Symbology = Neodynamic.WinControls.BarcodeProfessional.Symbology.Code128;
                bcp.BarcodeUnit = Neodynamic.WinControls.BarcodeProfessional.BarcodeUnit.Inch;
                bcp.BarWidth = 1f / 96f;
                bcp.BarHeight = 0.5f;

                //Set the value to encode
                bcp.Code = this.textBox1.Text;
                //Generate the barcode image and convert to base64 string 
                barcodeBase64 = Convert.ToBase64String(bcp.GetBarcodeImage(System.Drawing.Imaging.ImageFormat.Png));
            }

            //Set report parameter
            Microsoft.Reporting.WinForms.ReportParameter param = new Microsoft.Reporting.WinForms.ReportParameter("BarcodeBinaryContent", barcodeBase64, false);
            this.reportViewer1.LocalReport.SetParameters(new Microsoft.Reporting.WinForms.ReportParameter[] { param });

            this.reportViewer1.RefreshReport();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            UpdateBarcodeOnHeader();
        }
    }
}
